;Ohze upoh a tive
;ih a dalacg far far awag
;tJere lined vidJtg

;this is a helper alias
alias gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -s $1- : %c | return %c }

;this alias convert textures from .jpg to .bmp format
alias -l jpg2bmp {
  window -hpf @jpg2bmp1 0 0 512 512
  drawpic @jpg2bmp1 0 0 $+(",$scriptdirskyright.jpg,") | drawsave -b24 @jpg2bmp1 $+(",$scriptdirskyright.bmp,")
  close -@ @jpg2bmp1
}

;call this alias to see the demo
alias gldemo {
  clear

  ;first, we create a picture window... any HWND will do
  ;then we attach a rendering device to the window to perform initialization
  window -p @test 0 0 512 256
  window -r @test
  titlebar @test - Press any key to toggle the sky
  gl attach $window(@test).hwnd

  ;create font
  gl hint polygon_smooth_hint nicest
  gl bind_font 1
  gl create_font Symbol 800 RUSSIAN 0.08

  ;load sky texture
  if !$isfile($+(",$scriptdirskyright.bmp,")) { jpg2bmp }
  gl bind_texture 1
  gl load_texture $scriptdirskyright.bmp

  ;setup lights
  gl material front_and_back ambient 0.7 0.7 0 0
  gl material front_and_back diffuse 0.7 0.7 0 0
  gl light light0 position 0.2 -0.25 1 0


  ;let's compile some commands into a display list, for the sake of speed
  gl new_list 9990
  gl clear
  gl load_identity
  gl look_at 0 0 7 0 0 0 0 1 0
  gl rotate -45 1 0 0
  gl enable lighting
  gl disable texture_2d
  gl end_list

  ;another list. it prints all the text in the X0Y plane
  gl new_list 10000  

  ;dark yellow characters
  gl disable texture_2d
  gl material front_and_back specular 0.08 0.08 0.08 0

  ;print the lines at the top of the script file
  var %c = 1 | while %c < 4 {
    var %t = $right($read($script,%c),-1)
    gl print %t
    gl translate 0 $calc(-2 * $gl(text_height %t)) 0
    inc %c
  }

  ;bright yellow characters
  gl material front_and_back specular 0.2 0.2 0.2 0
  var %t = Nezrovah
  gl print %t

  ;before applying sky texture
  gl matrix_mode modelview
  gl load_identity
  gl matrix_mode projection
  gl push_matrix
  gl load_identity
  gl enable texture_2d
  gl disable lighting
  gl end_list 10000

  ;after sky texture
  gl new_list 10010
  gl pop_matrix
  gl matrix_mode modelview
  gl end_list 10010

  ;whether we should draw the sky
  set %gl_sky 1

  ;start rendering
  .timergl -m 0 1 gl_paint attach $window(@test).hwnd $calc($ticks + 20000) $!window(@test).dw $!window(@test).dh
}

;this is where we render graphics
alias gl_paint {
  dll nLIGHTn gl $1-2
  dll nLIGHTn gl call_list 9990
  dll nLIGHTn gl translate 0 $calc(($ticks - $3) / 5000) 0
  dll nLIGHTn gl call_list 10000

  if %gl_sky {
    dll nLIGHTn gl ortho 0 $4-5 0 -1 0.01
    dll nLIGHTn gl begin quads
    dll nLIGHTn gl tex_coord 0 1 | dll nLIGHTn gl vertex 0 0 
    dll nLIGHTn gl tex_coord 0 0 | dll nLIGHTn gl vertex 0 $5
    dll nLIGHTn gl tex_coord 1 0 | dll nLIGHTn gl vertex $4 $5
    dll nLIGHTn gl tex_coord 1 1 | dll nLIGHTn gl vertex $4 0
    dll nLIGHTn gl end
  }

  dll nLIGHTn gl call_list 10010
  dll nLIGHTn gl swap_buffers
}

;when you close the window, the timer should stop
on *:CLOSE:@test: .timergl off

;when the user presses a key, toggle the sky
on *:KEYDOWN:@test:*: %gl_sky = $iif(%gl_sky,0,1)

;cleanup
on *:UNLOAD: {
  unset %gl*
  .remove $+(",$scriptdirskyright.bmp,")
}
